require 'yaml'

module Almicube
  module Ranking
    autoload :Base, 'almicube/ranking/base'
    autoload :DataRanking, 'almicube/ranking/data_ranking'
    autoload :SubRanking, 'almicube/ranking/sub_ranking'
  end

  autoload :RangedRanking, 'almicube/ranged_ranking'
  autoload :Model, 'almicube/model'
  autoload :AssociationProxy, 'almicube/proxy/association_proxy'
  autoload :Config, 'almicube/config'
  autoload :Cog, 'almicube/cog'
  autoload :Key, 'almicube/key'

  autoload :Builder, 'almicube/builder'

  module Bundler
    autoload :Base, 'almicube/bundler/base'
    autoload :DaysAgoBundler, 'almicube/bundler/days_ago_bundler'
    autoload :TodayBundler, 'almicube/bundler/today_bundler'
    autoload :YesterdayBundler, 'almicube/bundler/yesterday_bundler'
    autoload :WeeklyBundler, 'almicube/bundler/weekly_bundler'
  end

  module Selector
    autoload :Base, 'almicube/selector/base'
    autoload :AllSelector, 'almicube/selector/all_selector'
    autoload :MethodSelector, 'almicube/selector/method_selector'
    autoload :HasManySelector, 'almicube/selector/has_many_selector'
  end

  module Aggregator
    autoload :Base, 'almicube/aggregator/base'
    autoload :SumAggregator, 'almicube/aggregator/sum_aggregator'
    autoload :AvgAggregator, 'almicube/aggregator/avg_aggregator'
  end

  if defined? ActiveRecord
    ActiveRecord::Base.send :include, Almicube::Model
  end

  if defined? Rails
    require 'almicube/engine'
  end
end
