module Almicube
  module Aggregator
    class Base
      include Almicube::Cog

      class << self
        def connection
          @redis ||= Almicube::Config.config.connection
        end
      end

      def aggregate(ranking=nil)
        self.ranking = ranking unless active? || ranking.nil?

        if self.ranking.data?
          data_aggregate self.ranking.key
        else
          sub_aggregate self.ranking.key
        end
      end

      protected

      def data_aggregate(key)
        ranking.records.each do |record|
          value = record.send(ranking.attribute_name) if record.respond_to? ranking.attribute_name
          value = ranking.default_score if value.nil?
          self.class.connection.zadd(key, value, record.to_param)
        end
      end
    end
  end
end
