module Almicube
  class Builder
    attr_accessor :selector, :date, :bundler, :class_name, :attribute_name

    def initialize(options={})
      @class_name = options[:class_name]
      @attribute_name = options[:attribute_name]
      @selector = select_selector(options[:selector])
      @bundler = select_bundler(options[:bundler])
      @date = options[:date] || Date.today
    end

    def data(date=nil)
      date ||= self.date
      Almicube::Ranking::DataRanking.new options.merge( date: date )
    end

    def options
      { selector: selector,
        bundler: bundler,
        date: date,
        class_name: class_name,
        attribute_name: attribute_name }
    end

    protected

    def select_selector(selector)
      selector = selector.constantize if selector.is_a?(String) && Object.const_defined?(selector.to_s)
      selector = selector.new if selector.is_a? Class
      selector
    end

    def select_bundler(bundler)
      bundler
    end
  end
end
