require 'active_model'

module Almicube
  class Config
    include ActiveModel::Model
    attr_accessor :connection, :key_format

    class << self
      def root
        Rails.root if defined? Rails
      end

      def filepath
        @filepath ||= File.join(root.to_s, "config", "almicube.yml")
      end

      def config
        if @instance.nil? && File.exists?(filepath)
          @instance = self.new YAML.load_file(filepath)
        end
        @instance ||= self.new {}
      end

      def reset
        @instance = nil
      end
    end

    def connection(env = :default)
      @connection ||= { default: nil }
      raise ArgumentError, "connection does not exist" unless @connection.has_key? env.to_sym
      @redis ||= Redis.new @connection[env] unless @connection[env].nil?
      @redis ||= Redis.new
    end

    def key_format
      @key_format ||= '%{prefix}:%{class_name}:%{attribute_name}:%{type}:%{distinction}:%{suffix}'
    end
  end
end
