module Almicube
  class AssociationProxy
    def initialize(ranking, item)
      raise TypeError, "without the Almicube::Ranking as #1 argument" unless ranking.kind_of? Ranking::Base
      @item = item
      @ranking = ranking
    end

    def score
      @ranking.score(@item)
    end

    def rank
      @ranking.rank(@item)
    end

    def incr(score = 1)
      @ranking.incr(@item, score)
    end

    def to_s
      "#{@item.to_s}: #{@ranking.key} [#{rank} - #{score}]"
    end
  end
end
