module Almicube
  module Ranking
    class SubRanking < Base
      attr_reader :ranking, :bundler

      def initialize(ranking, options={})
        super(options)

        @ranking = ranking
        self.selector ||= ranking.selector
        self.bundler = ( options[:bundler] || Almicube::Bundler::YesterdayBundler.new )
        @class_name ||= ranking.class_name
      end

      def key
        key = ranking.key.merge!( type: :built, suffix: suffix, selector: selector )
        key[:distinction] = "%{date}:in-%{selector}" unless selector.is_a? Selector::AllSelector
        key
      end

      def data_key
        ranking.key
      end

      def ranged(name)
        bundler_class = "Almicube::Bundler::#{name.to_s.classify}Bundler".constantize
        self.bundler = bundler_class.new if bundler_class.is_a? Class
        self
      end

      protected

      def suffix
        bundler.bundle unless bundler.nil?
      end
    end
  end
end
