module Almicube
  module Selector
    class HasManySelector < Base

      attr_reader :target, :association_name

      def initialize(options={})
        super(options)

        @target = options[:target]
        @association_name = options[:association_name]
      end

      def records
        target.send(association_name)
      end

      def label
        "#{target.class.to_s.underscore}-#{target.to_param}"
      end

      def before_aggregate
        records.map{ |r| r.to_param }.each do |i|
          Config.config.connection.zadd(interstore_key, 0, i)
        end
      end

      def interstore
        interstore_key
      end

      protected

      def interstore_key
        _key = ranking.key
        _key[:distinction] = label
        _key[:suffix] = ""
        _key
      end
    end
  end
end
