module Almicube
  module Selector
    class MethodSelector < Base
      attr_reader :accessor, :counter

      def initialize(options={})
        super(options)

        @accessor = options[:accessor] || :all
        @counter = options[:counter] || :count

        raise "invalid options" unless valid?
      end

      def records
        class_name.send(accessor)
      end

      def count
        class_name.send(counter)
      end

      def valid?
        validate_accessor
      end

      protected

      def validate_accessor
        class_name.class == Class && class_name.respond_to?(accessor)
      end
    end
  end
end
